#ifndef DLADSPA_CONSTANTS_H
#define DLADSPA_CONSTANTS_H

/******************************************************************************
 * Copyright (C) 2003 - Nelson Posse Lago
 *
 * This file is part of DLADSPA, a system for distributed processing
 * of LADSPA plugins.
 *
 * DLADSPA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * DLADSPA is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * or just check their website at http://www.fsf.org
 ******************************************************************************/


namespace DLADSPA {

enum {
    // This is the number of data blocks that are inserted by the proxy
    // class into the DataBlockVector that don't correspond to any LADSPA
    // ports. Currently, this is 2, for "functionToCall" and "sampleCount".
    // They are added to the beginning of the DataBlockSet.
    NUM_AUTOMATIC_ELEMENTS = 2,

    // This is the maximum size for each LADSPA_Data audio buffer (60KBytes).
    BUFFER_SIZE = 15360,

// These are the functions that we may call on the remote end.
    FUNCTION_RUN = 0,
    FUNCTION_RESET = 1 // Calls "deactivate" and "activate" on the remote plugin
};

#define MANAGER_DEFAULT_ADDRESS "127.0.0.1:3000"
#define MANAGER_ENV_NAME "DLADSPA_MANAGER"

#define DEFAULT_XML_PLUGIN_PATH "/usr/local/lib/dladspa"
#define XML_PLUGIN_PATH_ENV_NAME "DLASPA_PLUGINS_DIR"

} // namespace

#endif
