/******************************************************************************
 * Copyright (C) 2003 - Nelson Posse Lago
 *
 * This file is part of DLADSPA, a system for distributed processing
 * of LADSPA plugins.
 *
 * DLADSPA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * DLADSPA is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * or just check their website at http://www.fsf.org
 ******************************************************************************/

// FIXME How to make this file truly generic? Right now, we need to #include
// CORBA stuff that has been idl-compiled; this means this files needs to
// be edited for different projects...

#ifdef ORB_MICO
#include "plugin_factory/plugin_factory.h"
#include <mico/CosNaming.h>
#elif defined (ORB_OMNIORB)
#include "plugin_factory/plugin_factory.hh"
#endif

#include <string>

#include <miscutils/corba_option_parser.h>

// Define storage for the static class members
CORBA::ORB_ptr CORBAOptionParser::theOrb;
CosNaming::NamingContext_var CORBAOptionParser::theInc;
PortableServer::POA_ptr CORBAOptionParser::thePoa;

CORBAOptionParser::CORBAOptionParser (int& argc, char**& argv) :
    OptionParserBase (argc, argv)
{
    // Initialize the ORB
    theOrb = CORBA::ORB_init (argc, argv);

    // Find the initial naming context
    CORBA::Object_ptr obj = theOrb->resolve_initial_references ("NameService");
    theInc = CosNaming::NamingContext::_narrow (obj);
    CORBA::release (obj);

    // Initialize POA
    obj = theOrb->resolve_initial_references ("RootPOA");
    thePoa = PortableServer::POA::_narrow (obj);
    CORBA::release (obj);
    thePoa->the_POAManager()->activate();
};
