#ifndef CORBA_OPTION_PARSER_H
#define CORBA_OPTION_PARSER_H

/******************************************************************************
 * Copyright (C) 2003 - Nelson Posse Lago
 *
 * This file is part of DLADSPA, a system for distributed processing
 * of LADSPA plugins.
 *
 * DLADSPA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * DLADSPA is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * or just check their website at http://www.fsf.org
 ******************************************************************************/

/******************************************************************************
 * This class is derived from OptionParserBase to include CORBA ORB
 * initialization, the root POA and the Initial Naming Context.
 ******************************************************************************/

// Files that include this one probably need <string> and the CORBA stuff.

#include <miscutils/option_parser.h>

class CORBAOptionParser: public OptionParserBase
{
public:
    CORBAOptionParser (int& argc, char**& argv);
    CORBAOptionParser () { };
    CORBA::ORB_ptr orb () const { return theOrb; };
    CosNaming::NamingContext_var inc () const { return theInc; };
    PortableServer::POA_ptr poa () const { return thePoa; };
private:
    static CORBA::ORB_ptr theOrb;
    static CosNaming::NamingContext_var theInc;
    static PortableServer::POA_ptr thePoa;
};

#endif