/******************************************************************************
 * Copyright (C) 2003 - Nelson Posse Lago
 *
 * This file is part of DLADSPA, a system for distributed processing
 * of LADSPA plugins.
 *
 * DLADSPA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * DLADSPA is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * or just check their website at http://www.fsf.org
 ******************************************************************************/

#include <getopt.h>
#include <string>

#include <miscutils/option_parser.h>

using namespace std;

// Define storage for the static class members
bool OptionParserBase::initialized = false;
int OptionParserBase::argc;
char** OptionParserBase::argv;

OptionParserBase::OptionParserBase (int& argc, char**& argv)
{
    if (initialized)
        return;

    // Remove the leading path from our name
    char* c;
    if ((c = strrchr(argv[0], '/')) != 0) {
        ++c;
        argv[0] = c;
    }
    this->argc = argc;
    this->argv = argv;
    initialized = true;
};


OptionParserBase::OptionParserBase ()
{
    if (! initialized) {
        cerr << "OptionParserBase class: ";
        cerr << "a constructor with no parameters has been called," << endl;
        cerr <<  "but the arguments have not been parsed yet!" << endl;
        // FIXME!
        exit (1);
    }
};
