#ifndef OPTION_PARSER_H
#define OPTION_PARSER_H

/******************************************************************************
 * Copyright (C) 2003 - Nelson Posse Lago
 *
 * This file is part of DLADSPA, a system for distributed processing
 * of LADSPA plugins.
 *
 * DLADSPA is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * DLADSPA is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 * or just check their website at http://www.fsf.org
 ******************************************************************************/

/******************************************************************************
 * This file implements a class to handle command-line arguments.
 * This class is a singleton that is supposed to have methods
 * that return the parameters received on the command-line or a suitable
 * default.
 ******************************************************************************/


// Files that #include this one probably need to include <string>

class OptionParserBase {
public:
    OptionParserBase ();
    OptionParserBase (int& argc, char**& argv);
protected:
    virtual void usage (string&) { };
    static int argc;
    static char** argv;
private:
    static bool initialized;
};

#endif // ifndef OPTION_PARSER_H